"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Expression_expression, _Expression_interpreter;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Expression = void 0;
/**
 * Apply a JMESPath expression to a JSON value.
 */
class Expression {
    constructor(expression, interpreter) {
        _Expression_expression.set(this, void 0);
        _Expression_interpreter.set(this, void 0);
        __classPrivateFieldSet(this, _Expression_expression, expression, "f");
        __classPrivateFieldSet(this, _Expression_interpreter, interpreter, "f");
    }
    /**
     * Evaluate the expression against a JSON value.
     *
     * @param value The JSON value to apply the expression to.
     * @param node The node to visit.
     * @returns The result of applying the expression to the value.
     */
    visit(value, node) {
        return __classPrivateFieldGet(this, _Expression_interpreter, "f").visit(node ?? __classPrivateFieldGet(this, _Expression_expression, "f"), value);
    }
}
exports.Expression = Expression;
_Expression_expression = new WeakMap(), _Expression_interpreter = new WeakMap();
